SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetHistoricCampaigns]
(@Vcc					VARCHAR(50), 
 @ExcludesWorkGroupSup	BIT 
)
AS
BEGIN	
	
	
WITH ResultCampaing AS (
		SELECT 
			[AU].[Campaign]  'id',
			[AU].[Campaign]  'campaign'
		FROM [dbo].[Audio] AU (NOLOCK)
		WHERE [AU].[VCC] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [AU].[Campaign] NOT IN (SELECT WKS.CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
		UNION 
		SELECT 
			[IEP].[IdCampaign] AS 'id',
			[IEP].[IdCampaign] AS 'campaign'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE [IEP].[Instance] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [IEP].[IdCampaign] NOT IN  (SELECT WKS.CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
	)

	SELECT 
		R.id  'id', 
		R.campaign  'campaign' ,
		(
			SELECT STUFF((
				SELECT ',' + [idagent] + ''
				FROM (
					SELECT DISTINCT [AU2].[Agent]  'idagent'
					FROM [dbo].[Audio] AU2 (NOLOCK)
					WHERE [AU2].[VCC] = @Vcc AND [AU2].[Campaign] = R.id

					UNION

					SELECT DISTINCT [IE2].[IdAgent]  'idagent'
					FROM [dbo].[InteractionEvaluationPlan] IE2 (NOLOCK)
					WHERE [IE2].[Instance] = @Vcc AND [IE2].[IdCampaign] = R.id
				) agents
				FOR XML PATH(''), TYPE
			).value('.', 'NVARCHAR(MAX)'), 1, 1, '') 
		) AS 'agents'
	FROM ResultCampaing R
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
